#include <Adafruit_NeoPixel.h>
#include <NTPClient.h>
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>

#define RED   (255)
#define GREEN (242)
#define BLUE  (0) 

#define PIN D4
#define NUMPIXELS 25

const long utcOffsetInSeconds = 3600;
char daysOfTheWeek[7][12] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};

const char *ssid     = "Your SSID";
const char *password = "Your password. What did you thought? I m not fucking stupid!";

Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

// Define NTP Client to get time
WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "pool.ntp.org", utcOffsetInSeconds);

void clearAll(){
  int i = 0;
  for (i = 0; i<NUMPIXELS;i++){
    pixels.setPixelColor(i, pixels.Color(0,0,0));
  }
}

void setLed (int x, int y){
  int i = 0;
  if (x == 0){
    switch(y) {
      case 0: i = 0; break;
      case 1: i = 9; break;
      case 2: i = 10; break;
      case 3: i = 19; break;
      default: i = 20; break;
    }
  } else if (x == 1){
    switch(y) {
      case 0: i = 1; break;
      case 1: i = 8; break;
      case 2: i = 11; break;
      case 3: i = 18; break;
      default: i = 21; break;
    }
  } else if (x == 2){
    switch(y) {
      case 0: i = 2; break;
      case 1: i = 7; break;
      case 2: i = 12; break;
      case 3: i = 17; break;
      default: i = 22; break;
    }
  } else if (x == 3){
    switch(y) {
      case 0: i = 3; break;
      case 1: i = 6; break;
      case 2: i = 13; break;
      case 3: i = 16; break;
      default: i = 23; break;
    }
  } else if (x == 4){
    switch(y) {
      case 0: i = 4; break;
      case 1: i = 5; break;
      case 2: i = 14; break;
      case 3: i = 15; break;
      default: i = 24; break;
    }
  }
  pixels.setPixelColor(i, pixels.Color(RED,GREEN,BLUE));
}

void setTime(int hour, int min){
  int flag_genau = 0;
  
  setLed(0,4);  // Es ist...

  if (min >= 55){
    setLed(1,4);  // fuenf
    setLed(1,3);  // vor...
  } else if (min >= 50){
    setLed(2,4);  // zehn
    setLed(1,3);  // vor...
  } else if (min >= 45){
    setLed(3,4);  // viertel
    setLed(1,3);  // vor...
  } else if (min >= 40){
    setLed(4,4);  // zwanzig
    setLed(1,3);  // vor...
  } else if (min >= 35){
    setLed(1,4);  // fuenf
    setLed(2,3);  // nach
    setLed(3,3);  // halb...
  } else if (min >= 30){
    setLed(3,3);  // halb..
  } else if (min >= 25){
    setLed(1,4);  // fuenf
    setLed(1,3);  // vor
    setLed(3,3);  // halb...
  } else if (min >= 20){
    setLed(4,4);  // zwanzig
    setLed(2,3);  // nach...
  } else if (min >= 15){
    setLed(3,4);  // viertel
    setLed(2,3);  // nach...
  } else if (min >= 10){
    setLed(2,4);  // zehn
    setLed(2,3);  // nach...
  } else if (min >= 5){
    setLed(1,4);  // fuenf
    setLed(2,3);  // nach...
  } else {
    setLed(0,2);  // genau...
    flag_genau = 1;
  }

  if (min >= 30){
    switch (hour){
      case 0: setLed(2,2); break;   // eins
      case 1: setLed(3,2); break;   // zwei
      case 2: setLed(4,2); break;   // drei
      case 3: setLed(0,1); break;   // vier
      case 4: setLed(1,1); break;   // fuenf
      case 5: setLed(2,1); break;   // sechs
      case 6: setLed(3,1); break;   // sieben
      case 7: setLed(4,1); break;   // acht
      case 8: setLed(0,0); break;   // neun
      case 9: setLed(1,0); break;   // zehn
      case 10: setLed(2,0); break;   // elf
      case 11: setLed(0,3); break;   // zwoelf
      case 12: setLed(2,2); break;   // eins
      case 13: setLed(3,2); break;   // zwei
      case 14: setLed(4,2); break;   // drei
      case 15: setLed(0,1); break;   // vier
      case 16: setLed(1,1); break;   // fuenf
      case 17: setLed(2,1); break;   // sechs
      case 18: setLed(3,1); break;   // sieben
      case 19: setLed(4,1); break;   // acht
      case 20: setLed(0,0); break;   // neun
      case 21: setLed(1,0); break;   // zehn
      case 22: setLed(2,0); break;   // elf
      case 23: setLed(3,0); break;   // zwoelf
      default: setLed(2,2); break;   // eins
    }
  } else if (min >= 5){
    switch (hour){
      case 1: setLed(2,2); break;   // eins
      case 2: setLed(3,2); break;   // zwei
      case 3: setLed(4,2); break;   // drei
      case 4: setLed(0,1); break;   // vier
      case 5: setLed(1,1); break;   // fuenf
      case 6: setLed(2,1); break;   // sechs
      case 7: setLed(3,1); break;   // sieben
      case 8: setLed(4,1); break;   // acht
      case 9: setLed(0,0); break;   // neun
      case 10: setLed(1,0); break;   // zehn
      case 11: setLed(2,0); break;   // elf
      case 12: setLed(0,3); break;   // zwoelf
      case 13: setLed(2,2); break;   // eins
      case 14: setLed(3,2); break;   // zwei
      case 15: setLed(4,2); break;   // drei
      case 16: setLed(0,1); break;   // vier
      case 17: setLed(1,1); break;   // fuenf
      case 18: setLed(2,1); break;   // sechs
      case 19: setLed(3,1); break;   // sieben
      case 20: setLed(4,1); break;   // acht
      case 21: setLed(0,0); break;   // neun
      case 22: setLed(1,0); break;   // zehn
      case 23: setLed(2,0); break;   // elf
      case 24: setLed(3,0); break;   // zwoelf
      default: setLed(2,2); break;   // eins
    }
  } else {
    switch (hour){
      case 1: setLed(1,2); break;   // ein
      case 2: setLed(3,2); break;   // zwei
      case 3: setLed(4,2); break;   // drei
      case 4: setLed(0,1); break;   // vier
      case 5: setLed(1,1); break;   // fuenf
      case 6: setLed(2,1); break;   // sechs
      case 7: setLed(3,1); break;   // sieben
      case 8: setLed(4,1); break;   // acht
      case 9: setLed(0,0); break;   // neun
      case 10: setLed(1,0); break;   // zehn
      case 11: setLed(2,0); break;   // elf
      case 12: setLed(0,3); break;   // zwoelf
      case 13: setLed(1,2); break;   // ein
      case 14: setLed(3,2); break;   // zwei
      case 15: setLed(4,2); break;   // drei
      case 16: setLed(0,1); break;   // vier
      case 17: setLed(1,1); break;   // fuenf
      case 18: setLed(2,1); break;   // sechs
      case 19: setLed(3,1); break;   // sieben
      case 20: setLed(4,1); break;   // acht
      case 21: setLed(0,0); break;   // neun
      case 22: setLed(1,0); break;   // zehn
      case 23: setLed(2,0); break;   // elf
      case 24: setLed(3,0); break;   // zwoelf
      default: setLed(1,2); break;   // ein
    }
    setLed(4,0); // Uhr
  }
}

void setup(){
  pixels.begin();
  Serial.begin(115200);

  WiFi.begin(ssid, password);

  while ( WiFi.status() != WL_CONNECTED ) {
    digitalWrite(LED_BUILTIN, HIGH);
    delay ( 500 );
    Serial.print ( "." );
  }

  timeClient.begin();
}

void loop(){
  int hour = 0;
  int minutes = 0;
  
  timeClient.update();

  hour = timeClient.getHours();
  minutes = timeClient.getMinutes();

  Serial.print(daysOfTheWeek[timeClient.getDay()]);
  Serial.print(", ");
  Serial.print(hour);
  Serial.print(":");
  Serial.print(minutes);
  Serial.print(":");
  Serial.println(timeClient.getSeconds());

  clearAll();
  setTime(hour,minutes);
  pixels.show();
  delay(1000);
}
